local L = LibStub("AceLocale-3.0"):GetLocale("AVRE")
local zones = LibStub("AceLocale-3.0"):GetLocale("AVRE Zones")
local AVRE = AVRE
if not AVRE or not AVR then return end



--[[
      VARIABLES ----------------------------------------------------------------------------------------------------------------
  ]]




--[[
      UPVALUES -----------------------------------------------------------------------------------------------------------------
  ]]
  
local _G = getfenv(0)
local pairs = _G.pairs
local strlower = _G.strlower
local strupper = _G.strupper
local format = _G.format

local UnitAffectingCombat = _G.UnitAffectingCombat
local UnitGUID = _G.UnitGUID
local UnitName = _G.UnitName
local UnitInRaid = _G.UnitInRaid
local UnitIsDeadOrGhost = _G.UnitIsDeadOrGhost



--[[
      TESTS --------------------------------------------------------------------------------------------------------------------
  ]]

local testSubjectYou
local testSubjectOther

local tests = {

	{ fight = "marrowgar", desc = "Bone Spike", delay = 2, test = function()
			AVRE:OnCombatEvent("", GetTime(), "SPELL_SUMMON", "0x108086391105549245", testSubjectOther, 0, "0x108086391084506960", "Bone Spike", 0, 69062, "")
	end },
	
	{ fight = "marrowgar", desc = "-- spike died --", delay = 2, test = function()
			AVRE:OnCombatEvent("", GetTime(), "UNIT_DIED", "0x108086391105549245", testSubjectOther, 0, "0x108086391084506960", "Bone Spike", 0, 69062, "")
	end },
	
	{ fight = "marrowgar", desc = "Bone Spike", delay = 2, test = function()
			AVRE:OnCombatEvent("", GetTime(), "SPELL_SUMMON", "0x108086391105549245", testSubjectOther, 0, "0x108086391084506960", "Bone Spike", 0, 69062, "")
	end },
	
	{ fight = "marrowgar", desc = "-- player died --", delay = 2, test = function()
			AVRE:OnCombatEvent("", GetTime(), "UNIT_DIED", "0x108086391105549245", testSubjectOther, 0, "0x108086391105549245", testSubjectOther, 0, 69062, "")
	end },
	
	{ fight = "deathwhisper", desc = "Dominate Mind", delay = 14, test = function()
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_APPLIED", "0x108086391105549245", "Lady Deathwhisper", 0, "0x108086391084506960", testSubjectOther, 0, 71289, "")
	end },
	
	{ fight = "deathwhisper", desc = "Summon Spirit melee", delay = 7, test = function()
			AVRE:OnCombatEvent("", GetTime(), "SWING_DAMAGE", "0xF13000954E006C87", "Vengeful Shade", 0, "0x108086391084506960", testSubjectOther, 0, 71289, "")
	end },
	
	{ fight = "festergut", desc = "Gas Spore", delay = 14, test = function()
		AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_APPLIED", "0x108086391105549245", "Festergut", 0, "0x108086391084506960", testSubjectOther, 0, 69279, "")
	end },
	
	{ fight = "rotface", desc = "Explosion", delay = 12, test = function()
		AVRE:OnCombatEvent("", GetTime(), "SPELL_CAST_START", "0x108086391105549245", "src", 0, "0x108086391084506960", "dst", 0, 69839, "")
	end },
	
	{ fight = "putricide", desc = "Unbound Plague on you", delay = 3, test = function()
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_APPLIED", "0x108086391105549245", "Professor Putricide", 0, "0x108086391084506960", testSubjectYou, 0, 72855, "")
	end },
	
	{ fight = "putricide", desc = "Plague Sickness on someone else", delay = 3, test = function()
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_APPLIED", "0x108086391105549245", "Professor Putricide", 0, "0x108086391084506960", testSubjectOther, 0, 70953, "")
	end },
	
	{ fight = "putricide", desc = "-- plague sickness --", delay = 2, test = function()
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_REMOVED", "0x108086391105549245", "Professor Putricide", 0, "0x108086391084506960", testSubjectOther, 0, 70953, "")
	end },
	
	{ fight = "putricide", desc = "-- unbound plague --", delay = 2, test = function()
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_REMOVED", "0x108086391105549245", "Professor Putricide", 0, "0x108086391084506960", testSubjectYou, 0, 72855, "")
	end },
	
	{ fight = "putricide", desc = "Malleable Goo", delay = 7, test = function()
			AVRE:ForceBossTarget(36678, testSubjectYou)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_CAST_SUCCESS", "0x108086391105549245", "Professor Putricide", 0, "0x108086391084506960", testSubjectYou, 0, 72615, "")
			AVRE:ClearForcedBossTarget(0.5)
	end },
	
	{ fight = "bloodprince", desc = "Empowered Flame", delay = 8, test = function()
			AVRE:OnEvent("CHAT_MSG_RAID_BOSS_EMOTE", format("Empowered Flames speed toward %s!", testSubjectYou), "", "", "", testSubjectYou)
	end },
	
	{ fight = "bloodprince", desc = "Shock Vortex", delay = 7, test = function()
			AVRE:ForceBossTarget(37970, testSubjectYou)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_CAST_START", "0x108086391105549245", "", 0, "0x108086391084506960", testSubjectYou, 0, 72037, "")
			AVRE:ClearForcedBossTarget(0.5)
	end },
	
	{ fight = "sindragosa", desc = "Frost Beacon", delay = 8, test = function()
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_APPLIED", "0x108086391105549245", "Sindragosa", 0, "0x108086391084506960", testSubjectYou, 0, 70126, "")
	end },
	
	{ fight = "sindragosa", desc = "Unchained Magic (heroic)", delay = 5, test = function()
			AVRE:ForceHeroic(true)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_APPLIED", "0x108086391105549245", "Sindragosa", 0, "0x108086391084506960", testSubjectOther, 0, 69762, "")
			AVRE:ForceHeroic(nil)
	end },
	
	{ fight = "sindragosa", desc = "-- unchained magic (early) --", delay = 2, test = function()
			AVRE:ForceHeroic(true)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_AURA_REMOVED", "0x108086391105549245", "Sindragosa", 0, "0x108086391084506960", testSubjectOther, 0, 69762, "")
			AVRE:ForceHeroic(nil)
	end },
	
	{ fight = "lichking", desc = "Defile", delay = 4, test = function()
			AVRE:ForceBossTarget(36597, testSubjectYou)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_CAST_START", "0x108086391105549245", "", 0, "0x108086391084506960", testSubjectYou, 0, 72762, "")
			AVRE:ClearForcedBossTarget(0.5)
	end },
	
	{ fight = "lichking", desc = "Shadow Trap", delay = 6, test = function()
			AVRE:ForceBossTarget(36597, testSubjectYou)
			AVRE:OnCombatEvent("", GetTime(), "SPELL_CAST_START", "0x108086391105549245", "", 0, "0x108086391084506960", testSubjectYou, 0, 73539, "")
			AVRE:ClearForcedBossTarget(0.5)
	end },

}



--[[
      METHODS ------------------------------------------------------------------------------------------------------------------
  ]]

do
	local count = 0
	local cur = 1
	local defaultDelay
	local stop = 0
	
	local function doTest(v)
		AVRE:Print(format("[%d/%d]: %s (%s) for %d seconds", cur, count, v.fight, v.desc, v.delay or defaultDelay))
		if (AVRE.fight and AVRE.fight.enable.fight ~= v.fight) or not AVRE.fight then
			AVRE:StartFight(AVRE.enc[v.fight], 0, true)
		end
		AVRE.testing = true
		v.test()
		AVRE.testing = false
		cur = cur + 1
		if cur <= count and cur <= stop then
			AVRE:ScheduleTimer(function() doTest(tests[cur]) end, tests[cur-1].delay or defaultDelay)
		else
			AVRE:ScheduleTimer(function()
				AVRE:EndFight(true)
				AVRE:Print("Done with tests")
			end, tests[cur-1].delay or defaultDelay)
		end
	end
	
	function AVRE:RunTests(start, e, del)
		if not testSubjectYou then testSubjectYou = UnitName("player") end
		if not testSubjectOther then
			if not UnitName("target") then
				AVRE:Print("Please target another player nearby in your raid before beginning tests.")
				return
			end
			testSubjectOther = UnitName("target")
		end
		count = 0
		cur = 1
		if not del then defaultDelay = 10 else defaultDelay = del end
		for k, v in pairs(tests) do
			count = count + 1
		end
		if start and start <= count then cur = start end
		stop = count
		if e and e <= count then stop = e end
		doTest(tests[cur])
	end
	
end


function AVRE:TestZone(zone)
	AVRE.testZone = zone
	self:LoadZone()
end


function AVRE:ForceHeroic(value)
	AVRE.forceHeroic = value
end


function AVRE:ForceBossTarget(id, name)
	AVRE.forcedTargetNpc = id
	AVRE.forcedTargetName = name
end


function AVRE:ClearForcedBossTarget(delay)
	self:ScheduleTimer(function() self:ForceBossTarget(nil, nil) end, delay)
end


function AVRE:SetTestSubjectYou(n)
	testSubjectYou = n
end


function AVRE:SetTestSubjectOther(n)
	testSubjectOther = n
end
